package wordcount;

import java.util.Random;
import java.util.StringTokenizer;
import org.apache.log4j.Logger;
import streammine3G.Collector;
import streammine3G.Operator;
import wordcount.OperatorImpl;

public class WordCountMapper extends OperatorImpl
{
    private Logger logger;
    private Random rand; 
    private String randomSentences[] = new String[5]; 
    
    public WordCountMapper() 
    {   
        logger = Logger.getLogger(WordCountMapper.class);

        randomSentences[0] = "the cow jumped over the moon";
        randomSentences[1] = "an apple a day keeps the doctor away";
        randomSentences[2] = "four score and seven years ago";
        randomSentences[3] = "snow white and the seven dwarfs";
        randomSentences[4] = "i am at two with nature";

        rand = new Random(System.currentTimeMillis());
    }
    
    public boolean generate(Collector collector) 
    {
        String sentence = randomSentences[rand.nextInt(5)];
        collector.emitEvent(0, 0, sentence.getBytes());
        logger.info(" [\033[01;34m" + sentence+ "\033[0m]");
        return true;
    }
    
    public void process(int routingKey, byte[] event, Object state, Collector collector) 
    {
        String sentence = new String(event);
        StringTokenizer st = new StringTokenizer(sentence);
        while (st.hasMoreElements()) 
        {
            String word = st.nextToken();
            collector.emitEvent(0, 0, word.getBytes());
            
            logger.info(" [\033[01;31m" + word + "\033[0m]");
        }
    }
    
    public static Operator operatorInstance()
    {
        return  new WordCountMapper();
    }
}
