package wordcount;

import java.util.Map;
import java.util.HashMap;
import java.util.List;

import org.apache.commons.lang.SerializationUtils;
import org.apache.log4j.Logger;

import streammine3G.Collector;
import streammine3G.Operator;
import streammine3G.StateAccess;
import wordcount.OperatorImpl;

public class WordCountReducer extends OperatorImpl
{
    private Logger logger;

    public WordCountReducer()
    {
        logger = Logger.getLogger(WordCountReducer.class); 
    }
    
    @Override
    public void serializeState(Object state, List<byte[]> buffers)
    {
        @SuppressWarnings("unchecked")
        byte[] buf = SerializationUtils.serialize((HashMap<String, Integer>)state);
        buffers.add(buf);
    }
    
    @Override
    public Object stateInit()
    {
        return new HashMap<String, Integer>();
    }
    
    @Override
    public Object deserializeState(List<byte[]> buffers) 
    {
        byte[] buf = buffers.get(0);
        return SerializationUtils.deserialize(buf);
    }
    
        
    @Override
    public void stateAccess(int routingKey, byte[] event, StateAccess stateAccess) 
    {
        stateAccess.setKey(0);
    }
    
    @Override
    public void process(int routingKey, byte[] event, Object state, Collector collector) 
    {
        String word = new String(event);
        Integer count = new Integer(1);

        @SuppressWarnings("unchecked")
        Map<String, Integer> map = (Map<String, Integer>)state;
        if (map.containsKey(word)) count = new Integer(map.get(word).intValue()+1);
        map.put(word, count);
        
        logger.info("[\033[01;32m" + word + "\033[0m, " + count.intValue() + "]");
    }
    
    public static Operator operatorInstance()
    {
        return new WordCountReducer();
    }
}
